package ucot.iter2.graphspike;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;

import ucot.iter1.model.AnalyzeModel;
import ucot.iter1.model.Entity;
import ucot.iter1.model.Relation;
import ucot.iter1.model.Thing;

public class DummyWindow extends JFrame {
    
    public DummyWindow(AnalyzeModel am) {
        super();
        
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        this.setLayout(new BorderLayout());
        
        JComponent panel = new JComponent() {
            
            @Override
            protected void paintComponent(Graphics g) {
                // TODO Auto-generated method stub
                super.paintComponent(g);
                
                // Piirretn staattinen kuva nyttmn laatikoita..
                g.drawRect(5, 95, 90, 50);
                g.drawString("Jrjestelm", 10, 95 + g.getFontMetrics().getHeight());
                
                g.drawRect(300, 30, 90, 50);
                g.drawString("Kytttapaus", 305, 30 + g.getFontMetrics().getHeight());
                g.drawLine(95, 120, 175, 55);
                g.drawLine(175, 55, 300, 55);
                g.drawString("lukea", 195, 53);
                
                g.drawRect(300, 95, 90, 50);
                g.drawString("Oliokuvaus", 305, 95 + g.getFontMetrics().getHeight());
                g.drawLine(95, 120, 300, 120);
                g.drawString("tuottaa", 195, 118);
                
                g.drawRect(300, 160, 90, 50);
                g.drawString("Oliokuvaus", 305, 160 + g.getFontMetrics().getHeight());
                g.drawLine(95, 120, 175, 185);
                g.drawLine(175, 185, 300, 185);
                g.drawString("tallentaa", 195, 183);
                
            }
        };
        panel.setMinimumSize(new Dimension(350,400));
        
        JTree t = growTree(am);
        
        t.setMinimumSize(new Dimension(200,400));
        
        JSplitPane sp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, t, panel);
        
        
        this.getContentPane().add(sp, BorderLayout.CENTER);
        
        // menu
        this.setJMenuBar(new JMenuBar());
        
        JMenu m = new JMenu("File");
        m.add(new JMenuItem("Open"));
        m.add(new JMenuItem("Exit"));
        
        this.getJMenuBar().add(m);
        
        m = new JMenu("Program");
        m.add("Settings");
        
        this.getJMenuBar().add(m);
        
        this.setTitle("DummyWindowTest");
        this.setSize(700, 450);
        this.setVisible(true);
        
    }
    
    public void entityChanged(String name) {
        // this.setTitle("Entity: " + name);
    }
    
    /**
     * Method build the JTree from the AnalyzeModel.
     * @param am
     * @return
     */
    private JTree growTree(AnalyzeModel am) {
        
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Entiteetit");
        
        Set<Relation> relationsFrom = new HashSet<Relation>();
        
        for (Thing ent: am.getItemsType("entity")) {
            
            relationsFrom = am.getRelationsFrom(ent);
            
            DefaultMutableTreeNode entity = new DefaultMutableTreeNode(ent.getName());
            
            
            
            DefaultMutableTreeNode methods = new DefaultMutableTreeNode("metodit");
            
            for (Relation r: relationsFrom) {
                DefaultMutableTreeNode method = new DefaultMutableTreeNode(r.getName());
                method.add(new DefaultMutableTreeNode(r.getTo().getName()));
                methods.add(method);
            }
            
            if (relationsFrom.size() > 0) {
                entity.add(methods);
            }
            root.add(entity);
            
        }
        
        JTree t = new JTree(root);
        t.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        t.addTreeSelectionListener(new TreeSelectionListener() {
            
            public void valueChanged(TreeSelectionEvent e) {
                // TODO Auto-generated method stub
                
                
                entityChanged(e.getPath().toString());
                
            }
            
        });
        
        return t;
    }
    
    public static void main(String[] args) {
        
        AnalyzeModel am = new AnalyzeModel();
        
        // Nm napattu Panun Output.java:n main-esimerkist
        Relation r1 = new Relation(new Entity("kyttj"), "kirjoittaa",
                new Entity("kytttapaus"));
        Relation r2 = new Relation(new Entity("jrjestelm"), "lukea",
                new Entity("kytttapaus"));
        Relation r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = new Relation(new Entity("jrjestelm"), "lukea", new Entity(
        "kytttapaus"));
        r2 = new Relation(new Entity("jrjestelm"), "tuottaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = r2;
        r2 = new Relation(new Entity("kyttj"), "muokkaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = r2;
        r2 = new Relation(new Entity("jrjestelm"), "tallentaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        
        DummyWindow d = new DummyWindow(am);
    }
    
}
