package ucot.iter2.graphspike;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

import ucot.iter1.model.AnalyzeModel;
import ucot.iter1.model.Entity;
import ucot.iter1.model.Item;
import ucot.iter1.model.Relation;
import ucot.iter1.model.Thing;

public class TestWindow2 extends JFrame{
    
    // Entiteettilaatikon koko
    public static final int ENTITYSIZE_X = 90;
    public static final int ENTITYSIZE_Y = 50;
    
    public static Set<Item> entities;
    public AnalyzeModel model;
    
    
    public TestWindow2(AnalyzeModel am){
        model = am;
        entities = am.getItemsType("entity");

        
        
        
        // Paneli grafiikan esittmist varten.
        JComponent panel = new JComponent(){
            
            /**
             * Piirt yhden entiteetin(Thing) sinne minne ksketn
             * @param g
             * @param x
             * @param y
             * @param t
             */
            private void drawEntity(Graphics g, int x, int y, Thing t) {
                
                g.setColor(Color.BLACK);
                g.drawRect(x, y, ENTITYSIZE_X, ENTITYSIZE_Y);
                
                int margy = g.getFontMetrics().getHeight() + 5;
                int margx = 10;
                
                g.drawString(t.getName(), x + margx, y  + margy);
                
            }
            @Override
            
            // Metodi joka piirt grafiikat
            protected void paintComponent(Graphics g) {
                // TODO Auto-generated method stub
                super.paintComponent(g);
                
                int x = 20;
                int y = 15;
                
                for(Thing ent: entities) {
                    
                    Set<Relation> relfrom = model.getRelationsFrom(ent);
                  
                    // tmn osion koko, jos entiteetti ei viitt mihinkn koko on 110.
                    int dy = 15 + 65 * relfrom.size();
                    if (relfrom.size() == 0) dy = 110;
                    
                    // mihin viitattavat entiteetit piirretn
                    int relationY = y + 15;
                    
                    // piirretn pentiteetti puoleen vliin
                    drawEntity(g, x ,y + ((dy - ENTITYSIZE_Y) / 2), ent);
                    
                    // piirretn entiteetit joihin "pentiteetti" viittaa
                    for (Relation rel : relfrom) {
                        drawEntity(g, x + 300, relationY, rel.getTo());
                        
                        g.drawLine(x + ENTITYSIZE_X, y + dy/2, x + ENTITYSIZE_X + 80, relationY + (ENTITYSIZE_Y / 2));
                        g.drawLine(x + ENTITYSIZE_X + 80, relationY + (ENTITYSIZE_Y / 2),x + 300 ,relationY + (ENTITYSIZE_Y / 2));
                        
                        g.drawString(rel.getName(),x + ENTITYSIZE_X + 100 ,relationY + (ENTITYSIZE_Y / 2) - 2);
                        
                        relationY += 65;
                    }
                    
                    g.drawLine(5, y, 420, y);
                    
                    y += dy;
                }
            }
            
        };
        
        // Laitetaan panelille kokoa, jotta voidaan skrollailla.
        panel.setSize(1600,1600);
        panel.setMinimumSize(new Dimension(1600,1600));
        
        this.setLayout(new BorderLayout());
        
        // Tehdn scroll paneli.
        JScrollPane scrollpanel = new JScrollPane(panel);
        
        this.getContentPane().add(scrollpanel, BorderLayout.CENTER);
        this.setSize(1000,800);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setVisible(true);
    }
    public static void main(String[] args){
        
        AnalyzeModel am = new AnalyzeModel();
        
        // Nm napattu Panun Output.java:n main-esimerkist
        Relation r1 = new Relation(new Entity("kyttj"), "kirjoittaa",
                new Entity("kytttapaus"));
        Relation r2 = new Relation(new Entity("jrjestelm"), "lukea",
                new Entity("kytttapaus"));
        Relation r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = new Relation(new Entity("jrjestelm"), "lukea", new Entity(
        "kytttapaus"));
        r2 = new Relation(new Entity("jrjestelm"), "tuottaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = r2;
        r2 = new Relation(new Entity("kyttj"), "muokkaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        r1 = r2;
        r2 = new Relation(new Entity("jrjestelm"), "tallentaa", new Entity(
        "oliokuvaus"));
        r3 = new Relation(r1, "seuraa", r2);
        am.addRelation(r3);
        
        TestWindow2 tw = new TestWindow2(am);
    }
    
}
